
/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * OSOYOO IoT Tutorial: Use OSOYOO IoT APP to turn on/off LED
 * To run this code, you also need to install following libraries:
 * WifiEsp-master library, download link:https://osoyoo.com/driver/WiFiEsp-master.zip
 * PWMServo library, Download link:  https://osoyoo.com/driver/sg90car/PWMServo.zip 
 * Hardware: OSOYOO MEGA2560 board, MEGA IoT Wifi Shield , LED module
 * Tutorial link: https://osoyoo.com/?p=46253
 * CopyRIGHT www.osoyoo.com
*/
#include <WiFiEsp.h>
#include "OsoyooIOT.h"
#include "SoftwareSerial.h"
#define LED 2
OsoyooIOT udp;
SoftwareSerial softserial(A9, A8); // A9 to ESP8266_TX, A8 to ESP8266_RX by default

// WiFi
char ssid[] = "OSOYOO_SmartHome";  // replace *** with your network SSID (name)
int status = WL_IDLE_STATUS;  // the Wifi radio's status

unsigned int localPort = 8888;
 
 
void setup() {
  pinMode(LED, OUTPUT); 
 
  Serial.begin(9600);   // initialize serial for debugging
  softserial.begin(115200);
  softserial.write("AT+CIOBAUD=9600\r\n");
  softserial.write("AT+RST\r\n");
  softserial.begin(9600);    // initialize serial for ESP module
  WiFi.init(&softserial);    // initialize ESP module
  Serial.print("Attempting to start AP SSID ");
  Serial.println(ssid);
  status = WiFi.beginAP(ssid, 10, "", 0);

  Serial.println("You're connected to the network");
  Serial.println();
  Serial.println("Connected to wifi");
  printWifiStatus();

  Serial.println("\nStarting connection to server...");
  // if you get a connection, report back via serial:
  udp.begin(localPort);

  Serial.print("Listening on port ");
  Serial.println(localPort);
}

void loop() {
  udp.loop();
  if(udp.available()){
    OsoyooCommand myData = udp.read();
    Serial.print("Data Command:");
    String command = String(myData.command);
    Serial.print(command);
 
    Serial.print(" Data Value=");
    Serial.println(myData.data);
    int angle = map(myData.data, 0, 100, 0, 180);
    int brightness= map(myData.data, 0, 100, 0, 255);
    if (command =="F") digitalWrite(LED,HIGH);
    if (command =="G") digitalWrite(LED,LOW);


    if (command =="ST") {
      analogWrite(LED,brightness);
    }
 
  }
}

void printWifiStatus()
{
  // print your WiFi shield's IP address
  IPAddress ip = WiFi.localIP();
  Serial.print("IP Address: ");
  Serial.println(ip);

}